---
title: Proxy servers and tunneling
slug: Web/HTTP/Proxy_servers_and_tunneling
tags:
  - HTTP
  - HTTP Tunneling
  - Proxies
  - Proxy
---
<div>{{HTTPSidebar}}</div>

<p class="summary">When navigating through different networks of the Internet, proxy servers and HTTP tunnels are facilitating access to content on the World Wide Web. A proxy can be on the user's local computer, or anywhere between the user's computer and a destination server on the Internet. This page outlines some basics about proxies and introduces a few configuration options.</p>

<p>There are two types of proxies: <strong>forward proxies</strong> (or tunnel, or gateway) and<strong> reverse proxies</strong> (used to control and protect access to a server for load-balancing, authentication, decryption or caching).</p>

<h2 id="Forward_proxies">Forward proxies</h2>

<p>A forward proxy, or gateway, or just "proxy" provides proxy services to a client or a group of clients. There are likely hundreds of thousands of open forward proxies on the Internet. They store and forward Internet services (like the DNS, or web pages) to reduce and control the bandwidth used by the group.</p>

<p>Forward proxies can also be anonymous proxies and allow users to hide their IP address while browsing the Web or using other Internet services. <a href="https://www.torproject.org/">TOR</a> (The Onion Router), routes internet traffic through multiple proxies for anonymity.</p>

<h2 id="Reverse_proxies">Reverse proxies</h2>

<p>As the name implies, a reverse proxy does the opposite of what a forward proxy does: A forward proxy acts on behalf of clients (or requesting hosts). Forward proxies can hide the identities of clients whereas reverse proxies can hide the identities of servers. Reverse proxies have several use cases, a few are:</p>

<ul>
 <li>Load balancing: distribute the load to several web servers,</li>
 <li>Cache static content: offload the web servers by caching static content like pictures,</li>
 <li>Compression: compress and optimize content to speed up load time.</li>
</ul>

<h2 id="Forwarding_client_information_through_proxies">Forwarding client information through proxies</h2>

<p>Proxies can make requests appear as if they originated from the proxy's IP address. This can be useful if a proxy is used to provide client anonymity, but in other cases information from the original request is lost. The IP address of the original client is often used for debugging, statistics, or generating location-dependent content. A common way to disclose this information is by using the following HTTP headers:</p>

<p>The standardized header:</p>

<dl>
 <dt>{{HTTPHeader("Forwarded")}}</dt>
 <dd>Contains information from the client-facing side of proxy servers that is altered or lost when a proxy is involved in the path of the request.</dd>
</dl>

<p>Or the de-facto standard versions:</p>

<dl>
 <dt>{{HTTPHeader("X-Forwarded-For")}} {{non-standard_inline}}</dt>
 <dd>Identifies the originating IP addresses of a client connecting to a web server through an HTTP proxy or a load balancer.</dd>
 <dt>{{HTTPHeader("X-Forwarded-Host")}} {{non-standard_inline}}</dt>
 <dd>Identifies the original host requested that a client used to connect to your proxy or load balancer.</dd>
 <dt>{{HTTPHeader("X-Forwarded-Proto")}} {{non-standard_inline}}</dt>
 <dd>identifies the protocol (HTTP or HTTPS) that a client used to connect to your proxy or load balancer.</dd>
</dl>

<p>To provide information about the proxy itself (not about the client connecting to it), the <code>Via</code> header can be used.</p>

<dl>
 <dt>{{HTTPHeader("Via")}}</dt>
 <dd>Added by proxies, both forward and reverse proxies, and can appear in the request headers and the response headers.</dd>
</dl>

<h2 id="HTTP_tunneling">HTTP tunneling</h2>

<p>Tunneling transmits private network data and protocol information through public network by encapsulating the data. HTTP tunneling is using a protocol of higher level (HTTP) to transport a lower level protocol (TCP).</p>

<p>The HTTP protocol specifies a request method called {{HTTPMethod("CONNECT")}}. It starts two-way communications with the requested resource and can be used to open a tunnel. This is how a client behind an HTTP proxy can access websites using SSL (i.e. HTTPS, port 443). Note, however, that not all proxy servers support the <code>CONNECT</code> method or limit it to port 443 only.</p>

<p>See also the <a href="https://en.wikipedia.org/wiki/HTTP_tunnel">HTTP tunnel article on Wikipedia</a>.</p>

<h2 id="Proxy_Auto-Configuration_PAC">Proxy Auto-Configuration (PAC)</h2>

<p>A <a href="/en-US/docs/Web/HTTP/Proxy_servers_and_tunneling/Proxy_Auto-Configuration_(PAC)_file">Proxy Auto-Configuration (PAC)</a> file is a <a href="/en-US/docs/Web/JavaScript">JavaScript</a> function that determines whether web browser requests (HTTP, HTTPS, and FTP) go directly to the destination or are forwarded to a web proxy server. The JavaScript function contained in the PAC file defines the function:</p>

<p id="Saving_the_Auto-Config_File_Setting_the_MIME_Type">The auto-config file should be saved to a file with a <code>.pac</code> filename extension:</p>

<pre class="syntaxbox notranslate">proxy.pac</pre>

<p>And the MIME type set to:</p>

<pre class="syntaxbox notranslate">application/x-ns-proxy-autoconfig</pre>

<p>The file consists of a function called <code>FindProxyForURL</code>. The example below will work in an environment where the internal DNS server is set up so that it can only resolve internal host names, and the goal is to use a proxy only for hosts that aren't resolvable:</p>

<pre class="brush: js notranslate">function FindProxyForURL(url, host) {
  if (isResolvable(host))
    return "DIRECT";
  else
    return "PROXY proxy.mydomain.com:8080";
}</pre>

<p>See <a href="/en-US/docs/Web/HTTP/Proxy_servers_and_tunneling/Proxy_Auto-Configuration_(PAC)_file">Proxy Auto-Configuration (PAC)</a> for more examples.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTTPMethod("CONNECT")}}</li>
 <li><a href="https://en.wikipedia.org/wiki/Proxy_server">Proxy server on Wikipedia</a></li>
</ul>
